Package org.apache.tapestry5.services.pageload

## Class ComponentResourceSelector

- java.lang.Object
- - org.apache.tapestry5.services.pageload.ComponentResourceSelector

-     public final class ComponentResourceSelector
      extends java.lang.Object

  Encapsulates the information that is used when locating a template or message catalog associated with a component. The selector is combined with the component class name to locate the other resources. The selector defines one or more axes that are combined with a `ComponentResourceLocator` implementation to enforce a naming convention for locating resources. The primary axis is `Locale` (Tapestry 5.2 and earlier used a Locale instance as the selector), but Tapestry 5.3 adds support for additional axes.
  Since:
    5.3

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `java.util.Locale` | `locale` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ComponentResourceSelector​(java.util.Locale locale)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(java.lang.Object obj)` | Returns true if the object is another selector with the same locale and set of axis.
    `<T> T` | `getAxis​(java.lang.Class<T> axisType)` | Returns a previously stored axis value, or null if no axis value of the specified type has been stored.
    `int` | `hashCode()` |
    `java.lang.String` | `toShortString()` | Returns a string identifying the locale, and any additional axis types and values.
    `java.lang.String` | `toString()` |
    `<T> ComponentResourceSelector` | `withAxis​(java.lang.Class<T> axisType, T axisValue)` | Returns a new selector with the given axis data.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### locale

          public final java.util.Locale locale

  - ### Constructor Detail

    - #### ComponentResourceSelector

          public ComponentResourceSelector​(java.util.Locale locale)

  - ### Method Detail

    - #### withAxis

          public <T> ComponentResourceSelector withAxis​(java.lang.Class<T> axisType,
                                                        T axisValue)

      Returns a new selector with the given axis data. It is not allowed to redefine an existing axis type. Typically, the axis type is an enum type. Axis values are expected to be immutable, and to implement `equals()` and `hashCode()`.
      Parameters:
        `axisType` - non-blank axis key
        `axisValue` - non-null axis value
      Returns:
        new selector including axis value

    - #### getAxis

          public <T> T getAxis​(java.lang.Class<T> axisType)

      Returns a previously stored axis value, or null if no axis value of the specified type has been stored.
      Type Parameters:
        `T` -
      Parameters:
        `axisType` -
      Returns:
        value or null

    - #### equals

          public boolean equals​(java.lang.Object obj)

      Returns true if the object is another selector with the same locale and set of axis.
      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### toShortString

          public java.lang.String toShortString()

      Returns a string identifying the locale, and any additional axis types and values. Example, "en" or "fr com.example.Skin=RED".